import globalPluginHandler, scriptHandler, speechViewer, ui, braille, api
from keyboardHandler import KeyboardInputGesture
try:
  import speech.speech as speech
except ModuleNotFoundError:
  import speech

bd = braille.handler.display.name
keys = { 13580: ("1", "i", "space"),
  1357: ("1", "i", "6"),
  13578: ("1", "i", "3"),
  1358: ("1", "i", "4"),
  1350: ("1", "i", "7"),
  1234: ("q"),
  123480: ("q", "i", "space"),
  12347: ("q", "i", "6"),
  123478: ("q", "i", "3"),
  12348: ("q","i", "4"),
  12340: ("q","i", "7"),
  134: ("a"),
  13480: ("a", "i", "space"),
  1347: ("a", "i", "6"),
  13478: ("a", "i", "3"),
  1348: ("a", "i", "4"),
  1340: ("a", "i", "7"),
  12345: ("z"),
  123457: ("z", "i", "6"),
  145: ("2"),
  1457: ("2", "k", "6"),
  1450: ("2", "k", "7"),
  124: ("w"),
  1240: ("w", "k", "space"),
  1248: ("w", "k", "4"),
  1345: ("s"),
  13450: ("s", "k", "7"),
  13458: ("s", "k", "4"),
  14: ("x"),
  1480: ("x", "k", "space"),
  148: ("x", "k", "4"),
  140: ("x", "k", "7"),
  1380: ("e","k", "space"),
  137: ("e", "k", "6"),
  1378: ("e", "k", "3"),
  138: ("e", "k", "4"),
  130: ("e", "k", "7"),
  123: ("d"),
  1230: ("d", "k", "space"),
  1237: ("d", "k", "6"),
  12378: ("d", "k", "3"),
  1238: ("d", "k" "4"),
  1235: ("c"),
  12350: ("c", "k", "space"),
  12375: ("c", "k", "6"),
  12358: ("c", "k", "4"),
  10: ("5", "space"),
  17: ("5", "6"),
  178: ("5", "3"),
  18: ("5", "4"),
  12: ("t"),
  120: ("t", "space"),
  127: ("t", "6"),
  1278: ("t", "3"),
  128: ("t", "4"),
  24: ("g"),
  2480: ("g", "space"),
  247: ("g", "6"),
  2478: ("g", "3"),
  248: ("g", "4"),
  240: ("g", "7"),
  1245: ("b"),
  12458: ("b", "4"),
  125: ("y"),
  12580: ("y", "space"),
  12578: ("y", "3"),
  1258: ("y", "4"),
  1250: ("y", "space"),
  2450: ("h", "space"),
  2457: ("h", "6"),
  24578: ("h", "3"),
  2458: ("h", "4"),
  1580: ("n", "space"),
  1578: ("n", "3"),
  158: ("n", "4"),
  150: ("n", "7"),
  345: ("8", "space"),
  3457: ("8", "6"),
  34578: ("8", "3"),
  3458: ("8", "4"),
  3450: ("8", "7"),
  126: ("i", "space"),
  1267: ("i", "6"),
  12678: ("i", "3"),
  1268: ("i", "4"),
  1260: ("i", "7"),
  2346: ("k", "space"),
  23467: ("k", "6"),
  234678: ("k", "3"),
  2348: ("k", "4"),
  23460: ("k", "7"),
  268: (",", "4"),
  260: (",", "7"),
  2456: ("9", "space"),
  24567: ("9", "6"),
  245678: ("9", "3"),
  24568: ("9", "4"),
  24560: ("9", "7"),
  356: ("o", "space"),
  3567: ("o", "6"),
  35678: ("o", "3"),
  3568: ("o", "4"),
  3560: ("o", "7"),
  146: ("l", "space"),
  1467: ("l", "3"),
  14678: ("l", "3"),
  1468: ("l", "4"),
  1460: ("l", "7"),
  12356: (".", "space"),
  123567: (".", "6"),
  1235678: (".", "3"),
  123568: (".", "4"),
  123560: (".", "7"),
  1236: ("0", "space"),
  12367: ("0", "6"),
  123678: ("0", "3"),
  12368: ("0", "4"),
  136: ("p", "space"),
  1367: ("p", "6"),
  13678: ("p", "3"),
  1368: ("p", "4"),
  1360: ("p", "7"),
  1346: (";", "space"),
  13467: (";", "6"),
  134678: (";", "3"),
  13468: (";", "4"),
  1356: ("/", "space"),
  13567: ("/", "6"),
  135678: ("/", "3"),
  13568: ("/", "4"),
  1567: ("=", "6"),
  15678: ("=", "3"),
  1568: ("=", "4"),
  16: ("u", "space"),
  167: ("u", "6"),
  1678: ("u", "3"),
  168: ("u", "4"),
  160: ("u", "7"),
  34: ("j", "space"),
  347: ("j", "6"),
  3478: ("j", "3"),
  348: ("j", "4"),
  340: ("j", "7"),
  1256: ("m", "space"),
  12567: ("m", "6"),
  125678: ("m", "3"),
  12568: ("m", "4"),
  23456: ("u", "8", "space"),
  234567: ("u", "8", "6"),
  2345678: ("u", "8", "3"),
  234568: ("u", "8", "4"),
  234560: ("u", "8", "7"),
  35680: ("u", "i", "space"),
  346: ("u", ",", "space"),
  3467: ("u", ",", "6"),
  34678: ("u", ",", "3"),
  3468: ("u", ",", "4"),
  3460: ("u", ",", "7"),
  267: ("u", "9", "6"),
  246: ("u", "l", "space"),
  2467: ("u", "l", "6"),
  24678: ("u", "l", "3"),
  2468: ("u", "l", "4"),
  234: ("u", ".", "space"),
  2347: ("u", ".", "6"),
  23478: ("u", ".", "3"),
  2348: ("u", ".", "4"),
  2345: ("u", "0", "space"),
  23457: ("u", "0", "6"),
  234578: ("u", "0", "3"),
  23458: ("u", "0", "4"),
  1456: ("u", "p", "space"),
  14567: ("u", "p", "6"),
  145678: ("u", "p", "3"),
  14568: ("u", "p", "4"),
  46: ("u", ";", "space"),
  467: ("u", ";", "6"),
  4678: ("u", ";", "3"),
  468: ("u", ";", "4"),
  13456: ("u", "/", "space"),
  134567: ("u", "/", "6"),
  1345678: ("u", "/", "3"),
  134568: ("u", "/", "4"),
  35: ("j", "8", "space"),
  357: ("j", "8", "6"),
  3578: ("j", "8", "3"),
  358: ("j", "8", "4"),
  350: ("j", "8", "7"),
  25: ("j", "i", "space"),
  257: ("j", "i", "6"),
  2578: ("j", "i", "3"),
  258: ("j", "i", "4"),
  250: ("j", "i", "7"),
  2356: ("j", "9", "space"),
  23567: ("j", "9", "6"),
  235678: ("j", "9", "3"),
  23568: ("j", "9", "4"),
  1246: ("j", "o", "space"),
  12467: ("j", "o", "6"),
  124678: ("j", "o", "3"),
  12468: ("j", "o", "4"),
  12456: ("j", "0", "space"),
  124567: ("j", "0", "6"),
  1245678: ("j", "0", "3"),
  124568: ("j", "0", "4"),
  123456: ("j", "p", "space"),
  1234567: ("j", "p", "6"),
  12345678: ("j", "p", "3"),
  1234568: ("j", "p", "4"),
  456: ("j", ";", "space"),
  4567: ("j", ";", "6"),
  45678: ("j", ";", "3"),
  4568: ("j", ";", "4"),
  12346: ("j", "/", "space"),
  123467: ("j", "/", "6"),
  1234678: ("j", "/", "3"),
  123468: ("j", "/", "4"),
  236: ("m", ",", "space"),
  2367: ("m", ",", "6"),
  23678: ("m", ",", "3"),
  2368: ("m", ",", "4"),
  45: ("m", "0", "space"),
  457: ("m", "0", "6"),
  4578: ("m", "0", "3"),
  458: ("m", "0", "4"),
  256: ("m", "p", "space"),
  2567: ("m", "p", "6"),
  25678: ("m", "p", "3"),
  2568: ("m", "p", "4"),
  235: ("m",  "/", "sapce"),
  2357: ("m",  "/", "6"),
  23578: ("m",  "/", "3"),
  2358: ("m",  "/", "4") }
oldSpeak = speech.speak

consonant = []
toggle = False

def prefix(key):
  KeyboardInputGesture.fromName(key).send() 
  consonant.clear()

def mySpeak(sequence, *args, **kwargs):
  oldSpeak(sequence, *args, **kwargs)
  text = speechViewer.SPEECH_ITEM_SEPARATOR.join([x for x in sequence if isinstance(x, str)])
  global toggle
  if text == "中文輸入":
    toggle = True
  if text == "英數輸入":
    toggle = False
  speech.speak = oldSpeak

class GlobalPlugin(globalPluginHandler.GlobalPlugin):
  def script_chi(self, gesture):
    KeyboardInputGesture.fromName("shift").send()
    speech.speak = mySpeak
    global toggle
    toggle = not toggle
    if toggle:
      self.bindGestures(self.__chigestures)
    else:
      self.clearGestureBindings()
      self.bindGestures(self.__gestures)

  def script_135(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("`").send()
      KeyboardInputGesture.fromName("shift+0").send()
    else:
      KeyboardInputGesture.fromName("1").send()

  def script_13580(self, gesture):
    for i in keys[13580]:
      KeyboardInputGesture.fromName(i).send()

  def script_1357(self, gesture):
    for i in keys[1357]:
      KeyboardInputGesture.fromName(i).send()

  def script_13578(self, gesture):
    for i in keys[13578]:
      KeyboardInputGesture.fromName(i).send()

  def script_1358(self, gesture):
    for i in keys[1358]:
      KeyboardInputGesture.fromName(i).send()

  def script_1350(self, gesture):
    for i in keys[1350]:
      KeyboardInputGesture.fromName(i).send()

  def script_1234(self, gesture):
    for i in keys[1234]:
      KeyboardInputGesture.fromName(i).send()

  def script_123480(self, gesture):
    for i in keys[123480]:
      KeyboardInputGesture.fromName(i).send()

  def script_12347(self, gesture):
    for i in keys[12347]:
      KeyboardInputGesture.fromName(i).send()

  def script_123478(self, gesture):
    for i in keys[123478]:
      KeyboardInputGesture.fromName(i).send()

  def script_12348(self, gesture):
    for i in keys[12348]:
      KeyboardInputGesture.fromName(i).send()

  def script_12340(self, gesture):
    for i in keys[123480]:
      KeyboardInputGesture.fromName(i).send()

  def script_134(self, gesture):
    for i in keys[134]:
      KeyboardInputGesture.fromName(i).send()

  def script_13480(self, gesture):
    for i in keys[13480]:
      KeyboardInputGesture.fromName(i).send()

  def script_1347(self, gesture):
    for i in keys[1347]:
      KeyboardInputGesture.fromName(i).send()

  def script_13478(self, gesture):
    for i in keys[13478]:
      KeyboardInputGesture.fromName(i).send()

  def script_1348(self, gesture):
    for i in keys[1348]:
      KeyboardInputGesture.fromName(i).send()

  def script_1340(self, gesture):
    for i in keys[1340]:
      KeyboardInputGesture.fromName(i).send()

  def script_12345(self, gesture):
    for i in keys[12345]:
      KeyboardInputGesture.fromName(i).send()

  def script_123457(self, gesture):
    for i in keys[123457]:
      KeyboardInputGesture.fromName(i).send()

  def script_145(self, gesture):
    for i in keys[145]:
      KeyboardInputGesture.fromName(i).send()

  def script_1457(self, gesture):
    for i in keys[1457]:
      KeyboardInputGesture.fromName(i).send()

  def script_1450(self, gesture):
    for i in keys[1450]:
      KeyboardInputGesture.fromName(i).send()

  def script_124(self, gesture):
    for i in keys[124]:
      KeyboardInputGesture.fromName(i).send()

  def script_1240(self, gesture):
    for i in keys[1240]:
      KeyboardInputGesture.fromName(i).send()

  def script_1248(self, gesture):
    for i in keys[1248]:
      KeyboardInputGesture.fromName(i).send()

  def script_1345(self, gesture):
    for i in keys[1345]:
      KeyboardInputGesture.fromName(i).send()

  def script_13450(self, gesture):
    for i in keys[13450]:
      KeyboardInputGesture.fromName(i).send()

  def script_13458(self, gesture):
    for i in keys[13458]:
      KeyboardInputGesture.fromName(i).send()

  def script_14(self, gesture):
    for i in keys[14]:
      KeyboardInputGesture.fromName(i).send()

  def script_1480(self, gesture):
    for i in keys[1480]:
      KeyboardInputGesture.fromName(i).send()

  def script_148(self, gesture):
    for i in keys[148]:
      KeyboardInputGesture.fromName(i).send()

  def script_140(self, gesture):
    for i in keys[140]:
      KeyboardInputGesture.fromName(i).send()

  def script_13(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("e").send()
    else:
     global consonant
    consonant.extend(["e", "r"])

  def script_1380(self, gesture):
    for i in keys[1380]:
      KeyboardInputGesture.fromName(i).send()

  def script_137(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("r").send()
    else:
     for i in keys[137]:
      KeyboardInputGesture.fromName(i).send()

  def script_1378(self, gesture):
    for i in keys[1378]:
      KeyboardInputGesture.fromName(i).send()

  def script_138(self, gesture):
    for i in keys[138]:
      KeyboardInputGesture.fromName(i).send()

  def script_130(self, gesture):
    for i in keys[130]:
      KeyboardInputGesture.fromName(i).send()

  def script_123(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("control+shift+1").send()
    else:
      for i in keys[123]:
        KeyboardInputGesture.fromName(i).send()

  def script_1230(self, gesture):
    for i in keys[1230]:
      KeyboardInputGesture.fromName(i).send()

  def script_1237(self, gesture):
    for i in keys[1237]:
      KeyboardInputGesture.fromName(i).send()

  def script_12378(self, gesture):
    for i in keys[12378]:
      KeyboardInputGesture.fromName(i).send()

  def script_1238(self, gesture):
    for i in keys[1238]:
      KeyboardInputGesture.fromName(i).send()

  def script_1235(self, gesture):
    for i in keys[1235]:
      KeyboardInputGesture.fromName(i).send()

  def script_12350(self, gesture):
    for i in keys[12350]:
      KeyboardInputGesture.fromName(i).send()

  def script_12357(self, gesture):
    for i in keys[12357]:
      KeyboardInputGesture.fromName(i).send()

  def script_12358(self, gesture):
    for i in keys[12358]:
      KeyboardInputGesture.fromName(i).send()

  def script_1(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("7").send()
    else:
      KeyboardInputGesture.fromName("5").send()

  def script_10(self, gesture):
    for i in keys[10]:
      KeyboardInputGesture.fromName(i).send()

  def script_17(self, gesture):
    for i in keys[17]:
      KeyboardInputGesture.fromName(i).send()

  def script_178(self, gesture):
    for i in keys[178]:
      KeyboardInputGesture.fromName(i).send()

  def script_18(self, gesture):
    for i in keys[18]:
      KeyboardInputGesture.fromName(i).send()

  def script_12(self, gesture):
    for i in keys[12]:
      KeyboardInputGesture.fromName(i).send()

  def script_120(self, gesture):
    for i in keys[120]:
      KeyboardInputGesture.fromName(i).send()

  def script_127(self, gesture):
    for i in keys[127]:
      KeyboardInputGesture.fromName(i).send()

  def script_1278(self, gesture):
    for i in keys[1278]:
      KeyboardInputGesture.fromName(i).send()

  def script_128(self, gesture):
    for i in keys[128]:
      KeyboardInputGesture.fromName(i).send()

  def script_24(self, gesture):
    for i in keys[24]:
      KeyboardInputGesture.fromName(i).send()

  def script_2480(self, gesture):
    for i in keys[2480]:
      KeyboardInputGesture.fromName(i).send()

  def script_247(self, gesture):
    for i in keys[247]:
      KeyboardInputGesture.fromName(i).send()

  def script_2478(self, gesture):
    for i in keys[2478]:
      KeyboardInputGesture.fromName(i).send()

  def script_248(self, gesture):
    for i in keys[248]:
      KeyboardInputGesture.fromName(i).send()

  def script_240(self, gesture):
    for i in keys[240]:
      KeyboardInputGesture.fromName(i).send()

  def script_1245(self, gesture):
    for i in keys[1245]:
      KeyboardInputGesture.fromName(i).send()

  def script_12458(self, gesture):
    for i in keys[12458]:
      KeyboardInputGesture.fromName(i).send()

  def script_125(self, gesture):
    for i in keys[125]:
      KeyboardInputGesture.fromName(i).send()

  def script_12580(self, gesture):
    for i in keys[12580]:
      KeyboardInputGesture.fromName(i).send()

  def script_12578(self, gesture):
    for i in keys[12578]:
      KeyboardInputGesture.fromName(i).send()

  def script_1258(self, gesture):
    for i in keys[1258]:
      KeyboardInputGesture.fromName(i).send()

  def script_1250(self, gesture):
    for i in keys[1250]:
      KeyboardInputGesture.fromName(i).send()

  def script_245(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("h").send()
    else:
      global consonant
      consonant.extend(["h", "f"])

  def script_2450(self, gesture):
    for i in keys[2450]:
      KeyboardInputGesture.fromName(i).send()

  def script_2457(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("f").send()
    else:
      for i in keys[2457]:
        KeyboardInputGesture.fromName(i).send()

  def script_24578(self, gesture):
    for i in keys[24578]:
      KeyboardInputGesture.fromName(i).send()

  def script_2458(self, gesture):
    for i in keys[2458]:
      KeyboardInputGesture.fromName(i).send()

  def script_15(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("n").send()
    else:
      global consonant
      consonant.extend(["n", "v"])

  def script_1580(self, gesture):
    for i in keys[1580]:
      KeyboardInputGesture.fromName(i).send()

  def script_157(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("v").send()
    else:
      pass

  def script_1578(self, gesture):
    for i in keys[1578]:
      KeyboardInputGesture.fromName(i).send()

  def script_158(self, gesture):
    for i in keys[158]:
      KeyboardInputGesture.fromName(i).send()

  def script_150(self, gesture):
    for i in keys[150]:
      KeyboardInputGesture.fromName(i).send()

  def script_345(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("8").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[345]:
        KeyboardInputGesture.fromName(i).send()

  def script_3457(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3457]:
      KeyboardInputGesture.fromName(i).send()

  def script_34578(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[34578]:
      KeyboardInputGesture.fromName(i).send()

  def script_3458(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3458]:
      KeyboardInputGesture.fromName(i).send()

  def script_3450(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3450]:
      KeyboardInputGesture.fromName(i).send()

  def script_126(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("i").send()
    else:
      for i in keys[126]:
        KeyboardInputGesture.fromName(i).send()

  def script_1267(self, gesture):
    for i in keys[1267]:
      KeyboardInputGesture.fromName(i).send()

  def script_12678(self, gesture):
    for i in keys[12678]:
      KeyboardInputGesture.fromName(i).send()

  def script_1268(self, gesture):
    for i in keys[1268]:
      KeyboardInputGesture.fromName(i).send()

  def script_1260(self, gesture):
    for i in keys[1260]:
      KeyboardInputGesture.fromName(i).send()

  def script_2346(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("d").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[2346]:
        KeyboardInputGesture.fromName(i).send()

  def script_23467(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[23467]:
      KeyboardInputGesture.fromName(i).send()

  def script_234678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[234678]:
      KeyboardInputGesture.fromName(i).send()

  def script_23468(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[23468]:
      KeyboardInputGesture.fromName(i).send()

  def script_23460(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[23460]:
      KeyboardInputGesture.fromName(i).send()

  def script_26(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName(",").send()
    else:
      pass

  def script_268(self, gesture):
    for i in keys[268]:
      KeyboardInputGesture.fromName(i).send()

  def script_2456(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("9").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[2456]:
        KeyboardInputGesture.fromName(i).send()

  def script_24567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[24567]:
      KeyboardInputGesture.fromName(i).send()

  def script_245678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[245678]:
      KeyboardInputGesture.fromName(i).send()

  def script_24568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[24568]:
      KeyboardInputGesture.fromName(i).send()

  def script_24560(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[24560]:
      KeyboardInputGesture.fromName(i).send()

  def script_356(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("o").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[356]:
        KeyboardInputGesture.fromName(i).send()

  def script_3567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3567]:
      KeyboardInputGesture.fromName(i).send()

  def script_35678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[35678]:
      KeyboardInputGesture.fromName(i).send()

  def script_3568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3568]:
      KeyboardInputGesture.fromName(i).send()

  def script_3560(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3560]:
      KeyboardInputGesture.fromName(i).send()

  def script_146(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("l").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[146]:
        KeyboardInputGesture.fromName(i).send()

  def script_1467(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1467]:
      KeyboardInputGesture.fromName(i).send()

  def script_14678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[14678]:
      KeyboardInputGesture.fromName(i).send()

  def script_1468(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1468]:
      KeyboardInputGesture.fromName(i).send()

  def script_1460(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1460]:
      KeyboardInputGesture.fromName(i).send()

  def script_12356(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName(".").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[12356]:
        KeyboardInputGesture.fromName(i).send()

  def script_123567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[123567]:
      KeyboardInputGesture.fromName(i).send()

  def script_1235678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1235678]:
      KeyboardInputGesture.fromName(i).send()

  def script_123568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[123568]:
      KeyboardInputGesture.fromName(i).send()

  def script_123560(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[123560]:
      KeyboardInputGesture.fromName(i).send()

  def script_1236(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("0").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[1236]:
        KeyboardInputGesture.fromName(i).send()

  def script_12367(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[12367]:
      KeyboardInputGesture.fromName(i).send()

  def script_123678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[123678]:
      KeyboardInputGesture.fromName(i).send()

  def script_12368(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[12368]:
      KeyboardInputGesture.fromName(i).send()

  def script_136(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("p").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[136]:
        KeyboardInputGesture.fromName(i).send()

  def script_1367(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1367]:
      KeyboardInputGesture.fromName(i).send()

  def script_13678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[13678]:
      KeyboardInputGesture.fromName(i).send()

  def script_1368(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1368]:
      KeyboardInputGesture.fromName(i).send()

  def script_1360(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1360]:
      KeyboardInputGesture.fromName(i).send()

  def script_1346(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName(";").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[1346]:
        KeyboardInputGesture.fromName(i).send()

  def script_13467(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[13467]:
      KeyboardInputGesture.fromName(i).send()

  def script_134678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[134678]:
      KeyboardInputGesture.fromName(i).send()

  def script_13468(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[13468]:
      KeyboardInputGesture.fromName(i).send()

  def script_1356(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("/").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[1356]:
        KeyboardInputGesture.fromName(i).send()

  def script_13567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[13567]:
      KeyboardInputGesture.fromName(i).send()

  def script_135678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[135678]:
      KeyboardInputGesture.fromName(i).send()

  def script_13568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[13568]:
      KeyboardInputGesture.fromName(i).send()

  def script_156(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("-").send()
    else:
      pass

  def script_1567(self, gesture):
    for i in keys[1567]:
      KeyboardInputGesture.fromName(i).send()

  def script_15678(self, gesture):
    for i in keys[15678]:
      KeyboardInputGesture.fromName(i).send()

  def script_1568(self, gesture):
    for i in keys[1568]:
      KeyboardInputGesture.fromName(i).send()

  def script_16(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("u").send()
    else:
      if consonant:
        prefix(consonant[1])
      for i in keys[16]:
        KeyboardInputGesture.fromName(i).send()

  def script_167(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[167]:
      KeyboardInputGesture.fromName(i).send()

  def script_1678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[1678]:
      KeyboardInputGesture.fromName(i).send()

  def script_168(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[168]:
      KeyboardInputGesture.fromName(i).send()

  def script_160(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[160]:
      KeyboardInputGesture.fromName(i).send()

  def script_34(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("j").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[34]:
        KeyboardInputGesture.fromName(i).send()

  def script_347(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[347]:
      KeyboardInputGesture.fromName(i).send()

  def script_3478(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3478]:
      KeyboardInputGesture.fromName(i).send()

  def script_348(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[348]:
      KeyboardInputGesture.fromName(i).send()

  def script_340(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[340]:
      KeyboardInputGesture.fromName(i).send()

  def script_1256(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("m").send()
    else:
      if consonant:
        prefix(consonant[1])
      for i in keys[1256]:
        KeyboardInputGesture.fromName(i).send()

  def script_12567(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[12567]:
      KeyboardInputGesture.fromName(i).send()

  def script_125678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[125678]:
      KeyboardInputGesture.fromName(i).send()

  def script_12568(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[12568]:
      KeyboardInputGesture.fromName(i).send()

  def script_23456(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[23456]:
      KeyboardInputGesture.fromName(i).send()

  def script_234567(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[234567]:
      KeyboardInputGesture.fromName(i).send()

  def script_2345678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2345678]:
      KeyboardInputGesture.fromName(i).send()

  def script_234568(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[234568]:
      KeyboardInputGesture.fromName(i).send()

  def script_234560(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[234560]:
      KeyboardInputGesture.fromName(i).send()

  def script_35680(self, gesture):
    for i in keys[35680]:
      KeyboardInputGesture.fromName(i).send()

  def script_346(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[346]:
      KeyboardInputGesture.fromName(i).send()

  def script_3467(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[3467]:
      KeyboardInputGesture.fromName(i).send()

  def script_34678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[34678]:
      KeyboardInputGesture.fromName(i).send()

  def script_3468(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[3468]:
      KeyboardInputGesture.fromName(i).send()

  def script_3460(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[3460]:
      KeyboardInputGesture.fromName(i).send()

  def script_267(self, gesture):
    for i in keys[267]:
      KeyboardInputGesture.fromName(i).send()

  def script_246(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("`").send()
      KeyboardInputGesture.fromName("shift+9").send()
    else:
      if consonant:
        prefix(consonant[1])
      for i in keys[246]:
        KeyboardInputGesture.fromName(i).send()

  def script_2467(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2467]:
      KeyboardInputGesture.fromName(i).send()

  def script_24678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[24678]:
      KeyboardInputGesture.fromName(i).send()

  def script_2468(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2468]:
      KeyboardInputGesture.fromName(i).send()

  def script_234(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[234]:
      KeyboardInputGesture.fromName(i).send()

  def script_2347(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2347]:
      KeyboardInputGesture.fromName(i).send()

  def script_23478(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[23478]:
      KeyboardInputGesture.fromName(i).send()

  def script_2348(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2348]:
      KeyboardInputGesture.fromName(i).send()

  def script_2345(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2345]:
      KeyboardInputGesture.fromName(i).send()

  def script_23457(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[23457]:
      KeyboardInputGesture.fromName(i).send()

  def script_234578(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[234578]:
      KeyboardInputGesture.fromName(i).send()

  def script_23458(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[23458]:
      KeyboardInputGesture.fromName(i).send()

  def script_1456(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("control+shift+/").send()
    else:
      if consonant:
        prefix(consonant[1])
      for i in keys[1456]:
        KeyboardInputGesture.fromName(i).send()

  def script_14567(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[14567]:
      KeyboardInputGesture.fromName(i).send()

  def script_145678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[145678]:
      KeyboardInputGesture.fromName(i).send()

  def script_14568(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[14568]:
      KeyboardInputGesture.fromName(i).send()

  def script_46(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[46]:
      KeyboardInputGesture.fromName(i).send()

  def script_467(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[467]:
      KeyboardInputGesture.fromName(i).send()

  def script_4678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[4678]:
      KeyboardInputGesture.fromName(i).send()

  def script_468(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[468]:
      KeyboardInputGesture.fromName(i).send()

  def script_13456(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("control+]").send()
    else:
      if consonant:
        prefix(consonant[1])
      for i in keys[13456]:
        KeyboardInputGesture.fromName(i).send()

  def script_134567(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[134567]:
      KeyboardInputGesture.fromName(i).send()

  def script_1345678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[1345678]:
      KeyboardInputGesture.fromName(i).send()

  def script_134568(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[134568]:
      KeyboardInputGesture.fromName(i).send()

  def script_35(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[35]:
      KeyboardInputGesture.fromName(i).send()

  def script_357(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[357]:
      KeyboardInputGesture.fromName(i).send()

  def script_3578(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[3578]:
      KeyboardInputGesture.fromName(i).send()

  def script_358(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[358]:
      KeyboardInputGesture.fromName(i).send()

  def script_350(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[350]:
      KeyboardInputGesture.fromName(i).send()

  def script_25(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("control+shift+;").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[25]:
        KeyboardInputGesture.fromName(i).send()

  def script_257(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[257]:
      KeyboardInputGesture.fromName(i).send()

  def script_2578(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[2578]:
      KeyboardInputGesture.fromName(i).send()

  def script_258(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[258]:
      KeyboardInputGesture.fromName(i).send()

  def script_250(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[250]:
      KeyboardInputGesture.fromName(i).send()

  def script_2356(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[2356]:
      KeyboardInputGesture.fromName(i).send()

  def script_23567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[23567]:
      KeyboardInputGesture.fromName(i).send()

  def script_235678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[235678]:
      KeyboardInputGesture.fromName(i).send()

  def script_23568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[23568]:
      KeyboardInputGesture.fromName(i).send()

  def script_1246(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1246]:
      KeyboardInputGesture.fromName(i).send()

  def script_12467(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[12467]:
      KeyboardInputGesture.fromName(i).send()

  def script_124678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[124678]:
      KeyboardInputGesture.fromName(i).send()

  def script_12468(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[12468]:
      KeyboardInputGesture.fromName(i).send()

  def script_12456(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[12456]:
      KeyboardInputGesture.fromName(i).send()

  def script_124567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[124567]:
      KeyboardInputGesture.fromName(i).send()

  def script_1245678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1245678]:
      KeyboardInputGesture.fromName(i).send()

  def script_124568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[124568]:
      KeyboardInputGesture.fromName(i).send()

  def script_123456(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[123456]:
      KeyboardInputGesture.fromName(i).send()

  def script_1234567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1234567]:
      KeyboardInputGesture.fromName(i).send()

  def script_12345678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[12345678]:
      KeyboardInputGesture.fromName(i).send()

  def script_1234568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1234568]:
      KeyboardInputGesture.fromName(i).send()

  def script_456(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[456]:
      KeyboardInputGesture.fromName(i).send()

  def script_4567(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[4567]:
      KeyboardInputGesture.fromName(i).send()

  def script_45678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[45678]:
      KeyboardInputGesture.fromName(i).send()

  def script_4568(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[4568]:
      KeyboardInputGesture.fromName(i).send()

  def script_12346(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("control+[").send()
    else:
      if consonant:
        prefix(consonant[0])
      for i in keys[12346]:
        KeyboardInputGesture.fromName(i).send()

  def script_123467(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[123467]:
      KeyboardInputGesture.fromName(i).send()

  def script_1234678(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[1234678]:
      KeyboardInputGesture.fromName(i).send()

  def script_123468(self, gesture):
    if consonant:
      prefix(consonant[0])
    for i in keys[123468]:
      KeyboardInputGesture.fromName(i).send()

  def script_236(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[236]:
      KeyboardInputGesture.fromName(i).send()

  def script_2367(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2367]:
      KeyboardInputGesture.fromName(i).send()

  def script_23678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[23678]:
      KeyboardInputGesture.fromName(i).send()

  def script_2368(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2368]:
      KeyboardInputGesture.fromName(i).send()

  def script_45(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[45]:
      KeyboardInputGesture.fromName(i).send()

  def script_457(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[457]:
      KeyboardInputGesture.fromName(i).send()

  def script_4578(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[4578]:
      KeyboardInputGesture.fromName(i).send()

  def script_458(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[458]:
      KeyboardInputGesture.fromName(i).send()

  def script_256(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[256]:
      KeyboardInputGesture.fromName(i).send()

  def script_2567(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2567]:
      KeyboardInputGesture.fromName(i).send()

  def script_25678(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[25678]:
      KeyboardInputGesture.fromName(i).send()

  def script_2568(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2568]:
      KeyboardInputGesture.fromName(i).send()

  def script_235(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[235]:
      KeyboardInputGesture.fromName(i).send()

  def script_2357(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2357]:
      KeyboardInputGesture.fromName(i).send()

  def script_23578(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[23578]:
      KeyboardInputGesture.fromName(i).send()

  def script_2358(self, gesture):
    if consonant:
      prefix(consonant[1])
    for i in keys[2358]:
      KeyboardInputGesture.fromName(i).send()

  def script_3(self, gesture):
    KeyboardInputGesture.fromName("space").send()

  def script_2(self, gesture):
    KeyboardInputGesture.fromName("6").send()

  def script_4(self, gesture):
    KeyboardInputGesture.fromName("3").send()

  def script_5(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("`").send()
      KeyboardInputGesture.fromName("-").send()
      KeyboardInputGesture.fromName("downArrow").send()
      KeyboardInputGesture.fromName("6").send()
    else:
      KeyboardInputGesture.fromName("4").send()

  def script_23(self, gesture):
    KeyboardInputGesture.fromName("control+,").send()

  def script_230(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("control+]").send()
      KeyboardInputGesture.fromName("downArrow").send()
      KeyboardInputGesture.fromName("3").send()
    else:
      KeyboardInputGesture.fromName("control+]").send()
      KeyboardInputGesture.fromName("downArrow").send()
      KeyboardInputGesture.fromName("2").send()

  def script_36(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("`").send()
      KeyboardInputGesture.fromName("-").send()
      KeyboardInputGesture.fromName("downArrow").send()
      KeyboardInputGesture.fromName("5").send()
    else:
      KeyboardInputGesture.fromName("control+.").send()

  def script_6(self, gesture):
    KeyboardInputGesture.fromName("control+'").send()

  def script_56(self, gesture):
    KeyboardInputGesture.fromName("control+;").send()

  def script_560(self, gesture):
    if scriptHandler.getLastScriptRepeatCount() == 1:
      KeyboardInputGesture.fromName("backspace").send()
      KeyboardInputGesture.fromName("control+[").send()
      KeyboardInputGesture.fromName("downArrow").send()
      KeyboardInputGesture.fromName("3").send()
    else:
      KeyboardInputGesture.fromName("control+[").send()
      KeyboardInputGesture.fromName("downArrow").send()
      KeyboardInputGesture.fromName("2").send()

  __gestures = {f"br({bd}):dot4+dot5+dot6+brailleSpaceBar":"chi"}
  __chigestures = { f"br({bd}):dot1+dot3+dot5":"135",
    f"br({bd}):dot1+dot3+dot5+dot8+brailleSpaceBar":"13580",
    f"br({bd}):dot1+dot3+dot5+dot7":"1357",
    f"br({bd}):dot1+dot3+dot5+dot7+dot8":"13578",
    f"br({bd}):dot1+dot3+dot5+dot8":"1358",
    f"br({bd}):dot1+dot3+dot5+brailleSpaceBar":"1350",
    f"br({bd}):dot1+dot2+dot3+dot4":"1234",
    f"br({bd}):dot1+dot2+dot3+dot4+brailleSpaceBar":"12340",
    f"br({bd}):dot1+dot2+dot3+dot4+dot7":"12347",
    f"br({bd}):dot1+dot2+dot3+dot4+dot7+dot8":"123478",
    f"br({bd}):dot1+dot2+dot3+dot4+dot8":"12348",
    f"br({bd}):dot1+dot2+dot3+dot4+dot8+brailleSpaceBar":"123480",
    f"br({bd}):dot1+dot3+dot4":"134",
    f"br({bd}):dot1+dot3+dot4+dot8+brailleSpaceBar":"13480",
    f"br({bd}):dot1+dot3+dot4+dot7":"1347",
    f"br({bd}):dot1+dot3+dot4+dot7+dot8":"13478",
    f"br({bd}):dot1+dot3+dot4+dot8":"1348",
    f"br({bd}):dot1+dot3+dot4+brailleSpaceBar":"1340",
    f"br({bd}):dot1+dot2+dot3+dot4+dot5":"12345",
    f"br({bd}):dot1+dot2+dot3+dot4+dot5+dot7":"123457",
    f"br({bd}):dot1+dot4+dot5":"145",
    f"br({bd}):dot1+dot4+dot5+dot7":"1457",
    f"br({bd}):dot1+dot4+dot5+brailleSpaceBar":"1450",
    f"br({bd}):dot1+dot2+dot4":"124",
    f"br({bd}):dot1+dot2+dot4+brailleSpaceBar":"1240",
    f"br({bd}):dot1+dot2+dot4+dot8":"1248",
    f"br({bd}):dot1+dot3+dot4+dot5":"1345",
    f"br({bd}):dot1+dot3+dot4+dot5+brailleSpaceBar":"13450",
    f"br({bd}):dot1+dot3+dot4+dot5+dot8":"13458",
    f"br({bd}):dot1+dot4":"14",
    f"br({bd}):dot1+dot4+dot8+brailleSpaceBar":"1480",
    f"br({bd}):dot1+dot4+dot8":"148",
    f"br({bd}):dot1+dot4+brailleSpaceBar":"140",
    f"br({bd}):dot1+dot3":"13",
    f"br({bd}):dot1+dot3+dot8+brailleSpaceBar":"1380",
    f"br({bd}):dot1+dot3+dot7":"137",
    f"br({bd}):dot1+dot3+dot7+dot8":"1378",
    f"br({bd}):dot1+dot3+dot8":"138",
    f"br({bd}):dot1+dot3+brailleSpaceBar":"130",
    f"br({bd}):dot1+dot2+dot3":"123",
    f"br({bd}):dot1+dot2+dot3+brailleSpaceBar":"1230",
    f"br({bd}):dot1+dot2+dot3+dot7":"1237",
    f"br({bd}):dot1+dot2+dot3+dot7+dot8":"12378",
    f"br({bd}):dot1+dot2+dot3+dot8":"1238",
    f"br({bd}):dot1+dot2+dot3+dot5":"1235",
    f"br({bd}):dot1+dot2+dot3+dot5+brailleSpaceBar":"12350",
    f"br({bd}):dot1+dot2+dot3+dot5+dot7":"12357",
    f"br({bd}):dot1+dot2+dot3+dot5+dot8":"12358",
    f"br({bd}):dot1":"1",
    f"br({bd}):dot1+brailleSpaceBar":"10",
    f"br({bd}):dot1+dot7":"17",
    f"br({bd}):dot1+dot7+dot8":"178",
    f"br({bd}):dot1+dot8":"18",
    f"br({bd}):dot1+dot2":"12",
    f"br({bd}):dot1+dot2+brailleSpaceBar":"120",
    f"br({bd}):dot1+dot2+dot7":"127",
    f"br({bd}):dot1+dot2+dot7+dot8":"1278",
    f"br({bd}):dot1+dot2+dot8":"128",
    f"br({bd}):dot2+dot4":"24",
    f"br({bd}):dot2+dot4+dot8+brailleSpaceBar":"2480",
    f"br({bd}):dot2+dot4+dot7":"247",
    f"br({bd}):dot2+dot4+dot7+dot8":"2478",
    f"br({bd}):dot2+dot4+dot8":"248",
    f"br({bd}):dot2+dot4+brailleSpaceBar":"240",
    f"br({bd}):dot2+dot4+brailleSpaceBar":"240",
    f"br({bd}):dot1+dot2+dot4+dot5":"1245",
    f"br({bd}):dot1+dot2+dot4+dot5+dot8":"12458",
    f"br({bd}):dot1+dot2+dot5":"125",
    f"br({bd}):dot1+dot2+dot5+dot8+brailleSpaceBar":"12580",
    f"br({bd}):dot1+dot2+dot5+dot7+dot8":"12578",
    f"br({bd}):dot1+dot2+dot5+dot8":"1258",
    f"br({bd}):dot1+dot2+dot5+brailleSpaceBar":"1250",
    f"br({bd}):dot2+dot4+dot5":"245",
    f"br({bd}):dot2+dot4+dot5+brailleSpaceBar":"2450",
    f"br({bd}):dot2+dot4+dot5+dot7":"2457",
    f"br({bd}):dot2+dot4+dot5+dot7+dot8":"24578",
    f"br({bd}):dot2+dot4+dot5+dot8":"2458",
    f"br({bd}):dot1+dot5":"15",
    f"br({bd}):dot1+dot5+dot8+brailleSpaceBar":"1580",
    f"br({bd}):dot1+dot5+dot7":"157",
    f"br({bd}):dot1+dot5+dot7+dot8":"1578",
    f"br({bd}):dot1+dot5+dot8":"158",
    f"br({bd}):dot1+dot5+brailleSpaceBar":"150",
    f"br({bd}):dot3+dot4+dot5":"345",
    f"br({bd}):dot3+dot4+dot5+dot7":"3457",
    f"br({bd}):dot3+dot4+dot5+dot7+dot8":"34578",
    f"br({bd}):dot3+dot4+dot5+dot8":"3458",
    f"br({bd}):dot3+dot4+dot5+brailleSpaceBar":"3450",
    f"br({bd}):dot1+dot2+dot6":"126",
    f"br({bd}):dot1+dot2+dot6+dot7":"1267",
    f"br({bd}):dot1+dot2+dot6+dot7+dot8":"12678",
    f"br({bd}):dot1+dot2+dot6+dot8":"1268",
    f"br({bd}):dot1+dot2+dot6+brailleSpaceBar":"1260",
    f"br({bd}):dot2+dot3+dot4+dot6":"2346",
    f"br({bd}):dot2+dot3+dot4+dot6+dot7":"23467",
    f"br({bd}):dot2+dot3+dot4+dot6+dot7+dot8":"234678",
    f"br({bd}):dot2+dot3+dot4+dot6+dot8":"23468",
    f"br({bd}):dot2+dot3+dot4+dot6+brailleSpaceBar":"23460",
    f"br({bd}):dot2+dot6":"26",
    f"br({bd}):dot2+dot6+dot8":"268",
    f"br({bd}):dot2+dot4+dot5+dot6":"2456",
    f"br({bd}):dot2+dot4+dot5+dot6+dot7":"24567",
    f"br({bd}):dot2+dot4+dot5+dot6+dot7+dot8":"245678",
    f"br({bd}):dot2+dot4+dot5+dot6+dot8":"24568",
    f"br({bd}):dot2+dot4+dot5+dot6+brailleSpaceBar":"24560",
    f"br({bd}):dot3+dot5+dot6":"356",
    f"br({bd}):dot3+dot5+dot6+dot7":"3567",
    f"br({bd}):dot3+dot5+dot6+dot7+dot8":"35678",
    f"br({bd}):dot3+dot5+dot6+dot8":"3568",
    f"br({bd}):dot3+dot5+dot6+brailleSpaceBar":"3560",
    f"br({bd}):dot1+dot4+dot6":"146",
    f"br({bd}):dot1+dot4+dot6+dot7":"1467",
    f"br({bd}):dot1+dot4+dot6+dot7+dot8":"14678",
    f"br({bd}):dot1+dot4+dot6+dot8":"1468",
    f"br({bd}):dot1+dot4+dot6+brailleSpaceBar":"1460",
    f"br({bd}):dot1+dot2+dot3+dot5+dot6":"12356",
    f"br({bd}):dot1+dot2+dot3+dot5+dot6+dot7":"123567",
    f"br({bd}):dot1+dot2+dot3+dot5+dot6+dot7+dot8":"1235678",
    f"br({bd}):dot1+dot2+dot3+dot5+dot6+dot8":"123568",
    f"br({bd}):dot1+dot2+dot3+dot5+dot6+brailleSpaceBar":"123560",
    f"br({bd}):dot1+dot2+dot3+dot6":"1236",
    f"br({bd}):dot1+dot2+dot3+dot6+dot7":"12367",
    f"br({bd}):dot1+dot2+dot3+dot6+dot7+dot8":"123678",
    f"br({bd}):dot1+dot2+dot3+dot6+dot8":"12368",
    f"br({bd}):dot1+dot3+dot6":"136",
    f"br({bd}):dot1+dot3+dot6+dot7":"1367",
    f"br({bd}):dot1+dot3+dot6+dot7+dot8":"13678",
    f"br({bd}):dot1+dot3+dot6+dot8":"1368",
    f"br({bd}):dot1+dot3+dot6+brailleSpaceBar":"1360",
    f"br({bd}):dot1+dot3+dot4+dot6":"1346",
    f"br({bd}):dot1+dot3+dot4+dot6+dot7":"13467",
    f"br({bd}):dot1+dot3+dot4+dot6+dot7+dot8":"134678",
    f"br({bd}):dot1+dot3+dot4+dot6+dot8":"13468",
    f"br({bd}):dot1+dot3+dot5+dot6":"1356",
    f"br({bd}):dot1+dot3+dot5+dot6+dot7":"13567",
    f"br({bd}):dot1+dot3+dot5+dot6+dot7+dot8":"135678",
    f"br({bd}):dot1+dot3+dot5+dot6+dot8":"13568",
    f"br({bd}):dot1+dot5+dot6":"156",
    f"br({bd}):dot1+dot5+dot6+dot7":"1567",
    f"br({bd}):dot1+dot5+dot6+dot7+dot8":"15678",
    f"br({bd}):dot1+dot5+dot6+dot8":"1568",
    f"br({bd}):dot1+dot6":"16",
    f"br({bd}):dot1+dot6+dot7":"167",
    f"br({bd}):dot1+dot6+dot7+dot8":"1678",
    f"br({bd}):dot1+dot6+dot8":"168",
    f"br({bd}):dot1+dot6+brailleSpaceBar":"160",
    f"br({bd}):dot3+dot4":"34",
    f"br({bd}):dot3+dot4+dot7":"347",
    f"br({bd}):dot3+dot4+dot7+dot8":"3478",
    f"br({bd}):dot3+dot4+dot8":"348",
    f"br({bd}):dot3+dot4+brailleSpaceBar":"340",
    f"br({bd}):dot1+dot2+dot5+dot6":"1256",
    f"br({bd}):dot1+dot2+dot5+dot6+dot7":"12567",
    f"br({bd}):dot1+dot2+dot5+dot6+dot7+dot8":"125678",
    f"br({bd}):dot1+dot2+dot5+dot6+dot8":"12568",
    f"br({bd}):dot2+dot3+dot4+dot5+dot6":"23456",
    f"br({bd}):dot2+dot3+dot4+dot5+dot6+dot7":"234567",
    f"br({bd}):dot2+dot3+dot4+dot5+dot6+dot7+dot8":"2345678",
    f"br({bd}):dot2+dot3+dot4+dot5+dot6+dot8":"234568",
    f"br({bd}):+dot2+dot3+dot4+dot5+dot6+brailleSpaceBar":"234560",
    f"br({bd}):+dot3+dot5+dot6+dot8+brailleSpaceBar":"35680",
    f"br({bd}):+dot3+dot4+dot6":"346",
    f"br({bd}):dot3+dot4+dot6+dot7":"3467",
    f"br({bd}):dot3+dot4+dot6+dot7+dot8":"34678",
    f"br({bd}):dot3+dot4+dot6+dot8":"3468",
    f"br({bd}):dot3+dot4+dot6+brailleSpaceBar":"3460",
    f"br({bd}):dot2+dot6+dot7":"267",
    f"br({bd}):dot2+dot4+dot6":"246",
    f"br({bd}):dot2+dot4+dot6+dot7":"2467",
    f"br({bd}):dot2+dot4+dot6+dot7+dot8":"24678",
    f"br({bd}):dot2+dot4+dot6+dot8":"2468",
    f"br({bd}):dot2+dot3+dot4":"234",
    f"br({bd}):dot2+dot3+dot4+dot7":"2347",
    f"br({bd}):dot2+dot3+dot4+dot7+dot8":"23478",
    f"br({bd}):dot2+dot3+dot4+dot8":"2348",
    f"br({bd}):dot2+dot3+dot4+dot5":"2345",
    f"br({bd}):dot2+dot3+dot4+dot5+dot7":"23457",
    f"br({bd}):dot2+dot3+dot4+dot5+dot7+dot8":"234578",
    f"br({bd}):dot2+dot3+dot4+dot5+dot8":"23458",
    f"br({bd}):dot1+dot4+dot5+dot6":"1456",
    f"br({bd}):dot1+dot4+dot5+dot6+dot7":"14567",
    f"br({bd}):dot1+dot4+dot5+dot6+dot7+dot8":"145678",
    f"br({bd}):dot1+dot4+dot5+dot6+dot8":"14568",
    f"br({bd}):dot4+dot6":"46",
    f"br({bd}):dot4+dot6+dot7":"467",
    f"br({bd}):dot4+dot6+dot7+dot8":"4678",
    f"br({bd}):dot4+dot6+dot8":"468",
    f"br({bd}):dot1+dot3+dot4+dot5+dot6":"13456",
    f"br({bd}):dot1+dot3+dot4+dot5+dot6+dot7":"134567",
    f"br({bd}):dot1+dot3+dot4+dot5+dot6+dot7+dot8":"1345678",
    f"br({bd}):dot1+dot3+dot4+dot5+dot6+dot8":"134568",
    f"br({bd}):dot3+dot5":"35",
    f"br({bd}):dot3+dot5+dot7":"357",
    f"br({bd}):dot3+dot5+dot7+dot8":"3578",
    f"br({bd}):dot3+dot5+dot8":"358",
    f"br({bd}):dot3+dot5+brailleSpaceBar":"350",
    f"br({bd}):dot2+dot5":"25",
    f"br({bd}):dot2+dot5+dot7":"257",
    f"br({bd}):dot2+dot5+dot7+dot8":"2578",
    f"br({bd}):dot2+dot5+dot8":"258",
    f"br({bd}):dot2+dot5+brailleSpaceBar":"250",
    f"br({bd}):dot2+dot3+dot5+dot6":"2356",
    f"br({bd}):dot2+dot3+dot5+dot6+dot7":"23567",
    f"br({bd}):dot2+dot3+dot5+dot6+dot7+dot8":"235678",
    f"br({bd}):dot2+dot3+dot5+dot6+dot8":"23568",
    f"br({bd}):dot1+dot2+dot4+dot6":"1246",
    f"br({bd}):dot1+dot2+dot4+dot6+dot7":"12467",
    f"br({bd}):dot1+dot2+dot4+dot6+dot7+dot8":"124678",
    f"br({bd}):dot1+dot2+dot4+dot6+dot8":"12468",
    f"br({bd}):dot1+dot2+dot4+dot5+dot6":"12456",
    f"br({bd}):dot1+dot2+dot4+dot5+dot6+dot7":"124567",
    f"br({bd}):dot1+dot2+dot4+dot5+dot6+dot7+dot8":"1245678",
    f"br({bd}):dot1+dot2+dot4+dot5+dot6+dot8":"124568",
    f"br({bd}):dot1+dot2+dot3+dot4+dot5+dot6":"123456",
    f"br({bd}):dot1+dot2+dot3+dot4+dot5+dot6+dot7":"1234567",
    f"br({bd}):dot1+dot2+dot3+dot4+dot5+dot6+dot7+dot8":"12345678",
    f"br({bd}):dot1+dot2+dot3+dot4+dot5+dot6+dot8":"1234568",
    f"br({bd}):dot4+dot5+dot6":"456",
    f"br({bd}):dot4+dot5+dot6+dot7":"4567",
    f"br({bd}):dot4+dot5+dot6+dot7+dot8":"45678",
    f"br({bd}):dot4+dot5+dot6+dot8":"4568",
    f"br({bd}):dot1+dot2+dot3+dot4+dot6":"12346",
    f"br({bd}):dot1+dot2+dot3+dot4+dot6+dot7":"123467",
    f"br({bd}):dot1+dot2+dot3+dot4+dot6+dot7+dot8":"1234678",
    f"br({bd}):dot1+dot2+dot3+dot4+dot6+dot8":"123468",
    f"br({bd}):dot2+dot3+dot6":"236",
    f"br({bd}):dot2+dot3+dot6+dot7":"2367",
    f"br({bd}):dot2+dot3+dot6+dot7+dot8":"23678",
    f"br({bd}):dot2+dot3+dot6+dot8":"2368",
    f"br({bd}):dot4+dot5":"45",
    f"br({bd}):dot4+dot5+dot7":"457",
    f"br({bd}):dot4+dot5+dot7+dot8":"4578",
    f"br({bd}):dot4+dot5+dot8":"458",
    f"br({bd}):dot2+dot5+dot6":"256",
    f"br({bd}):dot2+dot5+dot6+dot7":"2567",
    f"br({bd}):dot2+dot5+dot6+dot7+dot8":"25678",
    f"br({bd}):dot2+dot5+dot6+dot8":"2568",
    f"br({bd}):dot2+dot3+dot5":"235",
    f"br({bd}):dot2+dot3+dot5+dot7":"2357",
    f"br({bd}):dot2+dot3+dot5+dot7+dot8":"23578",
    f"br({bd}):dot2+dot3+dot5+dot8":"2358",
    f"br({bd}):dot3":"3",
    f"br({bd}):dot2":"2",
    f"br({bd}):dot4":"4",
    f"br({bd}):dot5":"5",
    f"br({bd}):dot2+dot3":"23",
    f"br({bd}):dot2+dot3+brailleSpaceBar":"230",
    f"br({bd}):dot3+dot6":"36",
    f"br({bd}):dot6":"6",
    f"br({bd}):dot5+dot6":"56",
    f"br({bd}):dot5+dot6+brailleSpaceBar":"560" }
